diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/bundle.cc svn/extern/libmv/libmv/simple_pipeline/bundle.cc
--- trunk/extern/libmv/libmv/simple_pipeline/bundle.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/bundle.cc	2013-09-18 10:21:28.000000000 +0100
@@ -21,8 +21,10 @@
 #include "libmv/simple_pipeline/bundle.h"
 
 #include <map>
+#include <cmath>
 
 #include "ceres/ceres.h"
+#include "ceres/iteration_callback.h"
 #include "ceres/rotation.h"
 #include "libmv/base/vector.h"
 #include "libmv/logging/logging.h"
@@ -54,14 +56,42 @@
 
 namespace {
 
+// Convert a constrained focal length into an uncontrained bundle parameter for
+// passing to Ceres.
+template <typename T>
+T ConstrainFocalLength(const T focal_length,
+                       const double min_focal,
+                       const double max_focal) {
+  using std::asin;
+  return asin(-T(1) + (((focal_length - T(min_focal))
+                    / (T(max_focal) - T(min_focal)))
+                    * T(2.0)));
+}
+
+// Convert an unconstrained bundle parameter received from Ceres back to the
+// corresponding constrained focal length.
+template <typename T>
+T UnconstrainFocalLength(const T bundled_focal,
+                         const double min_focal,
+                         const double max_focal) {
+  using std::sin;
+  return T(min_focal) + (T(max_focal) - T(min_focal))
+                      * (T(1) + sin(bundled_focal))
+                      / T(2.0);
+}
+
 // Cost functor which computes reprojection error of 3D point X
 // on camera defined by angle-axis rotation and it's translation
 // (which are in the same block due to optimization reasons).
 //
 // This functor uses a radial distortion model.
 struct OpenCVReprojectionError {
-  OpenCVReprojectionError(const double observed_x, const double observed_y)
-      : observed_x(observed_x), observed_y(observed_y) {}
+  OpenCVReprojectionError(const double observed_x, const double observed_y,
+                          const double focal_length_min = 0.0,
+                          const double focal_length_max = 0.0)
+      : observed_x(observed_x), observed_y(observed_y),
+        focal_length_min(focal_length_min),
+        focal_length_max(focal_length_max) {}
 
   template <typename T>
   bool operator()(const T* const intrinsics,
@@ -98,11 +128,17 @@
 
     T predicted_x, predicted_y;
 
+    T unconstrained_focal = focal_length;
+    if (focal_length_min != 0.0 || focal_length_max != 0.0) {
+      unconstrained_focal = UnconstrainFocalLength(
+          focal_length, focal_length_min, focal_length_max);
+    }
+
     // Apply distortion to the normalized points to get (xd, yd).
     // TODO(keir): Do early bailouts for zero distortion; these are expensive
     // jet operations.
-    ApplyRadialDistortionCameraIntrinsics(focal_length,
-                                          focal_length,
+    ApplyRadialDistortionCameraIntrinsics(unconstrained_focal,
+                                          unconstrained_focal,
                                           principal_point_x,
                                           principal_point_y,
                                           k1, k2, k3,
@@ -119,6 +155,8 @@
 
   const double observed_x;
   const double observed_y;
+  const double focal_length_min;
+  const double focal_length_max;
 };
 
 // Print a message to the log which camera intrinsics are gonna to be optimixed.
@@ -148,34 +186,66 @@
 }
 
 // Pack intrinsics from object to an array for easier
-// and faster minimization.
-void PackIntrinisicsIntoArray(const CameraIntrinsics &intrinsics,
-                              double ceres_intrinsics[8]) {
-  ceres_intrinsics[OFFSET_FOCAL_LENGTH]       = intrinsics.focal_length();
-  ceres_intrinsics[OFFSET_PRINCIPAL_POINT_X]  = intrinsics.principal_point_x();
-  ceres_intrinsics[OFFSET_PRINCIPAL_POINT_Y]  = intrinsics.principal_point_y();
-  ceres_intrinsics[OFFSET_K1]                 = intrinsics.k1();
-  ceres_intrinsics[OFFSET_K2]                 = intrinsics.k2();
-  ceres_intrinsics[OFFSET_K3]                 = intrinsics.k3();
-  ceres_intrinsics[OFFSET_P1]                 = intrinsics.p1();
-  ceres_intrinsics[OFFSET_P2]                 = intrinsics.p2();
-}
-
-// Unpack intrinsics back from an array to an object.
-void UnpackIntrinsicsFromArray(const double ceres_intrinsics[8],
-                                 CameraIntrinsics *intrinsics) {
-    intrinsics->SetFocalLength(ceres_intrinsics[OFFSET_FOCAL_LENGTH],
-                               ceres_intrinsics[OFFSET_FOCAL_LENGTH]);
-
-    intrinsics->SetPrincipalPoint(ceres_intrinsics[OFFSET_PRINCIPAL_POINT_X],
-                                  ceres_intrinsics[OFFSET_PRINCIPAL_POINT_Y]);
-
-    intrinsics->SetRadialDistortion(ceres_intrinsics[OFFSET_K1],
-                                    ceres_intrinsics[OFFSET_K2],
-                                    ceres_intrinsics[OFFSET_K3]);
+// and faster minimization, constraining the focal length
+// according to the given BundleOptions.
+vector<Vec8> PackIntrinsics(const std::vector<CameraIntrinsics> &intrinsics,
+                            const BundleOptions &bundle_options) {
+  int num_intrinsics = intrinsics.size();
+  vector<Vec8> ceres_intrinsics(num_intrinsics);
+
+  for (int i = 0; i < num_intrinsics; ++i) {
+    if (bundle_options.constraints & BUNDLE_CONSTRAIN_FOCAL_LENGTH) {
+      ceres_intrinsics[i][OFFSET_FOCAL_LENGTH] = ConstrainFocalLength(
+          intrinsics[i].focal_length(),
+          bundle_options.focal_length_min,
+          bundle_options.focal_length_max);
+    } else {
+      ceres_intrinsics[i][OFFSET_FOCAL_LENGTH] = intrinsics[i].focal_length();
+    }
+    ceres_intrinsics[i][OFFSET_PRINCIPAL_POINT_X]  = intrinsics[i].principal_point_x();
+    ceres_intrinsics[i][OFFSET_PRINCIPAL_POINT_Y]  = intrinsics[i].principal_point_y();
+    ceres_intrinsics[i][OFFSET_K1]                 = intrinsics[i].k1();
+    ceres_intrinsics[i][OFFSET_K2]                 = intrinsics[i].k2();
+    ceres_intrinsics[i][OFFSET_K3]                 = intrinsics[i].k3();
+    ceres_intrinsics[i][OFFSET_P1]                 = intrinsics[i].p1();
+    ceres_intrinsics[i][OFFSET_P2]                 = intrinsics[i].p2();
+  }
+
+  return ceres_intrinsics;
+}
+
+// Unpack intrinsics back from an array to an object, converting
+// unconstrained bundle parameter to constrained focal length.
+std::vector<CameraIntrinsics> UnpackIntrinsics(
+    const vector<Vec8> &ceres_intrinsics,
+    const BundleOptions &bundle_options) {
+  int num_intrinsics = ceres_intrinsics.size();
+  std::vector<CameraIntrinsics> intrinsics(num_intrinsics);
+
+  for (int i = 0; i < num_intrinsics; ++i) {
+    if (bundle_options.constraints & BUNDLE_CONSTRAIN_FOCAL_LENGTH) {
+      double focal_length = UnconstrainFocalLength(
+          ceres_intrinsics[i][OFFSET_FOCAL_LENGTH],
+          bundle_options.focal_length_min,
+          bundle_options.focal_length_max);
+      intrinsics[i].SetFocalLength(focal_length, focal_length);
+    } else {
+      intrinsics[i].SetFocalLength(ceres_intrinsics[i][OFFSET_FOCAL_LENGTH],
+                                   ceres_intrinsics[i][OFFSET_FOCAL_LENGTH]);
+    }
+
+    intrinsics[i].SetPrincipalPoint(ceres_intrinsics[i][OFFSET_PRINCIPAL_POINT_X],
+                                    ceres_intrinsics[i][OFFSET_PRINCIPAL_POINT_Y]);
+
+    intrinsics[i].SetRadialDistortion(ceres_intrinsics[i][OFFSET_K1],
+                                      ceres_intrinsics[i][OFFSET_K2],
+                                      ceres_intrinsics[i][OFFSET_K3]);
+
+    intrinsics[i].SetTangentialDistortion(ceres_intrinsics[i][OFFSET_P1],
+                                          ceres_intrinsics[i][OFFSET_P2]);
+  }
 
-    intrinsics->SetTangentialDistortion(ceres_intrinsics[OFFSET_P1],
-                                        ceres_intrinsics[OFFSET_P2]);
+  return intrinsics;
 }
 
 // Get a vector of camera's rotations denoted by angle axis
@@ -183,45 +253,45 @@
 //
 // Element with index i matches to a rotation+translation for
 // camera at image i.
-vector<Vec6> PackCamerasRotationAndTranslation(
+vector<Vec6> PackViewsRotationAndTranslation(
     const Tracks &tracks,
     const EuclideanReconstruction &reconstruction) {
-  vector<Vec6> all_cameras_R_t;
+  vector<Vec6> all_views_R_t;
   int max_image = tracks.MaxImage();
 
-  all_cameras_R_t.resize(max_image + 1);
+  all_views_R_t.resize(max_image + 1);
 
   for (int i = 0; i <= max_image; i++) {
-    const EuclideanCamera *camera = reconstruction.CameraForImage(i);
+    const EuclideanView *view = reconstruction.ViewForImage(i);
 
-    if (!camera) {
+    if (!view) {
       continue;
     }
 
-    ceres::RotationMatrixToAngleAxis(&camera->R(0, 0),
-                                     &all_cameras_R_t[i](0));
-    all_cameras_R_t[i].tail<3>() = camera->t;
+    ceres::RotationMatrixToAngleAxis(&view->R(0, 0),
+                                     &all_views_R_t[i](0));
+    all_views_R_t[i].tail<3>() = view->t;
   }
-  return all_cameras_R_t;
+  return all_views_R_t;
 }
 
 // Convert cameras rotations fro mangle axis back to rotation matrix.
-void UnpackCamerasRotationAndTranslation(
+void UnpackViewsRotationAndTranslation(
     const Tracks &tracks,
-    const vector<Vec6> &all_cameras_R_t,
+    const vector<Vec6> &all_views_R_t,
     EuclideanReconstruction *reconstruction) {
   int max_image = tracks.MaxImage();
 
   for (int i = 0; i <= max_image; i++) {
-    EuclideanCamera *camera = reconstruction->CameraForImage(i);
+    EuclideanView *view = reconstruction->ViewForImage(i);
 
-    if (!camera) {
+    if (!view) {
       continue;
     }
 
-    ceres::AngleAxisToRotationMatrix(&all_cameras_R_t[i](0),
-                                     &camera->R(0, 0));
-    camera->t = all_cameras_R_t[i].tail<3>();
+    ceres::AngleAxisToRotationMatrix(&all_views_R_t[i](0),
+                                     &view->R(0, 0));
+    view->t = all_views_R_t[i].tail<3>();
   }
 }
 
@@ -280,8 +350,8 @@
       int max_image = tracks.MaxImage();
       bool is_first_camera = true;
       for (int i = 0; i <= max_image; i++) {
-        const EuclideanCamera *camera = reconstruction->CameraForImage(i);
-        if (camera) {
+        const EuclideanView *view = reconstruction->ViewForImage(i);
+        if (view) {
           double *current_camera_R_t = &(*all_cameras_R_t)[i](0);
 
           // All cameras are variable now.
@@ -312,42 +382,68 @@
 
 }  // namespace
 
+BundleOptions::BundleOptions() :
+  bundle_intrinsics(BUNDLE_NO_INTRINSICS),
+  constraints(BUNDLE_NO_CONSTRAINTS),
+  focal_length_min(0.0),
+  focal_length_max(0.0),
+  iteration_callback(NULL) {
+}
+
 void EuclideanBundle(const Tracks &tracks,
                      EuclideanReconstruction *reconstruction) {
-  CameraIntrinsics intrinsics;
+  BundleOptions bundle_options;
+
+  std::vector<CameraIntrinsics> empty_intrinsics;
   EuclideanBundleCommonIntrinsics(tracks,
-                                  BUNDLE_NO_INTRINSICS,
-                                  BUNDLE_NO_CONSTRAINTS,
+                                  bundle_options,
                                   reconstruction,
-                                  &intrinsics,
-                                  NULL);
+                                  empty_intrinsics);
 }
 
+void EuclideanBundleModal(const Tracks &tracks,
+                          EuclideanReconstruction *reconstruction) {
+  BundleOptions bundle_options;
+  bundle_options.constraints = libmv::BUNDLE_NO_TRANSLATION;
+
+  std::vector<CameraIntrinsics> empty_intrinsics;
+  EuclideanBundleCommonIntrinsics(tracks,
+                                  bundle_options,
+                                  reconstruction,
+                                  empty_intrinsics);
+}
+ 
 void EuclideanBundleCommonIntrinsics(const Tracks &tracks,
-                                     const int bundle_intrinsics,
-                                     const int bundle_constraints,
+                                     const BundleOptions &bundle_options,
                                      EuclideanReconstruction *reconstruction,
-                                     CameraIntrinsics *intrinsics,
+                                     std::vector<CameraIntrinsics> &intrinsics,
                                      BundleEvaluation *evaluation) {
-  LG << "Original intrinsics: " << *intrinsics;
+  const int bundle_intrinsics = bundle_options.bundle_intrinsics;
+  const int bundle_constraints = bundle_options.constraints;
+
+  //LG << "Original intrinsics: " << *intrinsics;
   vector<Marker> markers = tracks.AllMarkers();
 
+  int num_cameras = tracks.MaxCamera() + 1;
+  if (intrinsics.size() < num_cameras) {
+    intrinsics.resize(num_cameras);
+  }
+
   ceres::Problem::Options problem_options;
   ceres::Problem problem(problem_options);
 
   // Residual blocks with 10 parameters are unwieldly with Ceres, so pack the
   // intrinsics into a single block and rely on local parameterizations to
   // control which intrinsics are allowed to vary.
-  double ceres_intrinsics[8];
-  PackIntrinisicsIntoArray(*intrinsics, ceres_intrinsics);
+  vector<Vec8> ceres_intrinsics = PackIntrinsics(intrinsics, bundle_options);
 
-  // Convert cameras rotations to angle axis and merge with translation
+  // Convert views rotations to angle axis and merge with translation
   // into single parameter block for maximal minimization speed.
   //
   // Block for minimization has got the following structure:
   //   <3 elements for angle-axis> <3 elements for translation>
-  vector<Vec6> all_cameras_R_t =
-    PackCamerasRotationAndTranslation(tracks, *reconstruction);
+  vector<Vec6> all_views_R_t =
+    PackViewsRotationAndTranslation(tracks, *reconstruction);
 
   // Parameterization used to restrict camera motion for modal solvers.
   ceres::SubsetParameterization *constant_translation_parameterization = NULL;
@@ -365,37 +461,46 @@
 
   // Add residual blocks to the problem.
   int num_residuals = 0;
-  bool have_locked_camera = false;
+  bool have_locked_view = false;
   for (int i = 0; i < markers.size(); ++i) {
     const Marker &marker = markers[i];
-    EuclideanCamera *camera = reconstruction->CameraForImage(marker.image);
+    EuclideanView *view = reconstruction->ViewForImage(marker.image);
     EuclideanPoint *point = reconstruction->PointForTrack(marker.track);
-    if (camera == NULL || point == NULL) {
+    if (view == NULL || point == NULL) {
       continue;
     }
 
+    int camera = view->camera;
+
     // Rotation of camera denoted in angle axis followed with
     // camera translaiton.
-    double *current_camera_R_t = &all_cameras_R_t[camera->image](0);
+    double *current_view_R_t = &all_views_R_t[view->image](0);
 
+    OpenCVReprojectionError *cost_function;
+    if (bundle_options.constraints & BUNDLE_CONSTRAIN_FOCAL_LENGTH) {
+      cost_function = new OpenCVReprojectionError(
+          marker.x, marker.y,
+          bundle_options.focal_length_min,
+          bundle_options.focal_length_max);
+    } else {
+      cost_function = new OpenCVReprojectionError(marker.x, marker.y);
+    }
+                                                  
     problem.AddResidualBlock(new ceres::AutoDiffCostFunction<
-        OpenCVReprojectionError, 2, 8, 6, 3>(
-            new OpenCVReprojectionError(
-                marker.x,
-                marker.y)),
+        OpenCVReprojectionError, 2, 8, 6, 3>(cost_function),
         NULL,
-        ceres_intrinsics,
-        current_camera_R_t,
+        &ceres_intrinsics[camera](0),
+        current_view_R_t,
         &point->X(0));
 
     // We lock the first camera to better deal with scene orientation ambiguity.
-    if (!have_locked_camera) {
-      problem.SetParameterBlockConstant(current_camera_R_t);
-      have_locked_camera = true;
+    if (!have_locked_view) {
+      problem.SetParameterBlockConstant(current_view_R_t);
+      have_locked_view = true;
     }
 
     if (bundle_constraints & BUNDLE_NO_TRANSLATION) {
-      problem.SetParameterization(current_camera_R_t,
+      problem.SetParameterization(current_view_R_t,
                                   constant_translation_parameterization);
     }
 
@@ -413,7 +518,7 @@
   if (bundle_intrinsics == BUNDLE_NO_INTRINSICS) {
     // No camera intrinsics are being refined,
     // set the whole parameter block as constant for best performance.
-    problem.SetParameterBlockConstant(ceres_intrinsics);
+    problem.SetParameterBlockConstant(&ceres_intrinsics[0](0));
   } else {
     // Set the camera intrinsics that are not to be bundled as
     // constant using some macro trickery.
@@ -438,7 +543,11 @@
     ceres::SubsetParameterization *subset_parameterization =
       new ceres::SubsetParameterization(8, constant_intrinsics);
 
-    problem.SetParameterization(ceres_intrinsics, subset_parameterization);
+    problem.SetParameterization(&ceres_intrinsics[0](0), subset_parameterization);
+  }
+
+  for (int i = 1; i < ceres_intrinsics.size(); ++i) {
+    problem.SetParameterBlockConstant(&ceres_intrinsics[i](0));
   }
 
   // Configure the solver.
@@ -448,6 +557,9 @@
   options.linear_solver_type = ceres::ITERATIVE_SCHUR;
   options.use_inner_iterations = true;
   options.max_num_iterations = 100;
+  if (bundle_options.iteration_callback != NULL) {
+    options.callbacks.push_back(bundle_options.iteration_callback);
+  }
 
 #ifdef _OPENMP
   options.num_threads = omp_get_max_threads();
@@ -461,18 +573,20 @@
   LG << "Final report:\n" << summary.FullReport();
 
   // Copy rotations and translations back.
-  UnpackCamerasRotationAndTranslation(tracks,
-                                      all_cameras_R_t,
-                                      reconstruction);
+  UnpackViewsRotationAndTranslation(tracks,
+                                    all_views_R_t,
+                                    reconstruction);
 
   // Copy intrinsics back.
-  if (bundle_intrinsics != BUNDLE_NO_INTRINSICS)
-    UnpackIntrinsicsFromArray(ceres_intrinsics, intrinsics);
+  if (bundle_intrinsics != BUNDLE_NO_INTRINSICS) {
+    intrinsics = UnpackIntrinsics(ceres_intrinsics,
+                                  bundle_options);
+  }
 
-  LG << "Final intrinsics: " << *intrinsics;
+  //LG << "Final intrinsics: " << *intrinsics;
 
   if (evaluation) {
-    EuclideanBundlerPerformEvaluation(tracks, reconstruction, &all_cameras_R_t,
+    EuclideanBundlerPerformEvaluation(tracks, reconstruction, &all_views_R_t,
                                       &problem, evaluation);
   }
 }
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/bundle.h svn/extern/libmv/libmv/simple_pipeline/bundle.h
--- trunk/extern/libmv/libmv/simple_pipeline/bundle.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/bundle.h	2013-09-18 01:41:53.000000000 +0100
@@ -21,6 +21,10 @@
 #ifndef LIBMV_SIMPLE_PIPELINE_BUNDLE_H
 #define LIBMV_SIMPLE_PIPELINE_BUNDLE_H
 
+#include <vector>
+
+#include "ceres/types.h"
+#include "ceres/iteration_callback.h"
 #include "libmv/numeric/numeric.h"
 
 namespace libmv {
@@ -78,6 +82,27 @@
 /*!
     Refine camera poses and 3D coordinates using bundle adjustment.
 
+    This routine adjusts all cameras and points in \a *reconstruction. This
+    assumes a full observation for reconstructed tracks; this implies that if
+    there is a reconstructed 3D point (a bundle) for a track, then all markers
+    for that track will be included in the minimization. \a tracks should
+    contain markers used in the initial reconstruction.
+
+    The cameras and bundles (3D points), except the camera positions, are
+    refined in-place.
+
+    \note This assumes an outlier-free set of markers.
+    \note This assumes a calibrated reconstruction, e.g. the markers are
+          already corrected for camera intrinsics and radial distortion.
+
+    \sa EuclideanResect, EuclideanIntersect, EuclideanReconstructTwoFrames
+*/
+void EuclideanBundleModal(const Tracks &tracks,
+                          EuclideanReconstruction *reconstruction);
+
+/*!
+    Refine camera poses and 3D coordinates using bundle adjustment.
+
     This routine adjusts all cameras positions, points, and the camera
     intrinsics (assumed common across all images) in \a *reconstruction. This
     assumes a full observation for reconstructed tracks; this implies that if
@@ -91,7 +116,7 @@
     For example it is useful to keep camera translations constant
     when bundling tripod motions.
 
-    If evaluaiton is not null, different evaluation statistics is filled in
+    If evaluation is not null, different evaluation statistics is filled in
     there, plus all the requested additional information (like jacobian) is
     also calculating there. Also see comments for BundleEvaluation.
 
@@ -110,15 +135,36 @@
   BUNDLE_TANGENTIAL_P2 = 32,
   BUNDLE_TANGENTIAL = 48,
 };
+
 enum BundleConstraints {
   BUNDLE_NO_CONSTRAINTS = 0,
   BUNDLE_NO_TRANSLATION = 1,
+  BUNDLE_CONSTRAIN_FOCAL_LENGTH = 2
+};
+
+struct BundleOptions {
+  BundleOptions();
+
+  // Bitfield denoting the camera intrinsics to adjust during
+  // bundling. Use BundleIntrinsics flags.
+  short bundle_intrinsics;
+
+  // Bitfield denoting the constraints to place on bundle parameters.
+  // Use BundleConstraints flags.
+  int constraints;
+
+  // Minimum and maximum constraints for the focal length. To be useful,
+  // BUNDLE_CONSTRAIN_FOCAL_LENGTH flag must be set on constraints.
+  double focal_length_min, focal_length_max;
+
+  // Callback which is called after each iteration of the solver.
+  ceres::IterationCallback *iteration_callback;
 };
+
 void EuclideanBundleCommonIntrinsics(const Tracks &tracks,
-                                     const int bundle_intrinsics,
-                                     const int bundle_constraints,
+                                     const BundleOptions &bundle_options,
                                      EuclideanReconstruction *reconstruction,
-                                     CameraIntrinsics *intrinsics,
+                                     std::vector<CameraIntrinsics> &intrinsics,
                                      BundleEvaluation *evaluation = NULL);
 
 /*!
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.cc svn/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.cc
--- trunk/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.cc	2013-09-14 11:24:31.000000000 +0100
@@ -32,15 +32,18 @@
 namespace libmv {
 namespace {
 
-void GetImagesInMarkers(const vector<Marker> &markers,
-                        int *image1, int *image2) {
+void GetImagesAndCamerasInMarkers(const vector<Marker> &markers,
+                                  int *image1, int *image2,
+                                  int *camera1, int *camera2) {
   if (markers.size() < 2) {
     return;
   }
   *image1 = markers[0].image;
+  *camera1 = markers[0].camera;
   for (int i = 1; i < markers.size(); ++i) {
     if (markers[i].image != *image1) {
       *image2 = markers[i].image;
+      *camera2 = markers[i].camera;
       return;
     }
   }
@@ -58,7 +61,8 @@
   }
 
   int image1, image2;
-  GetImagesInMarkers(markers, &image1, &image2);
+  int camera1, camera2;
+  GetImagesAndCamerasInMarkers(markers, &image1, &image2, &camera1, &camera2);
 
   Mat x1, x2;
   CoordinatesForMarkersInImage(markers, image1, &x1);
@@ -85,8 +89,8 @@
   }
 
   // Image 1 gets the reference frame, image 2 gets the relative motion.
-  reconstruction->InsertCamera(image1, Mat3::Identity(), Vec3::Zero());
-  reconstruction->InsertCamera(image2, R, t);
+  reconstruction->InsertView(image1, Mat3::Identity(), Vec3::Zero(), camera1);
+  reconstruction->InsertView(image2, R, t, camera2);
 
   LG << "From two frame reconstruction got:\nR:\n" << R
      << "\nt:" << t.transpose();
@@ -146,7 +150,8 @@
   }
 
   int image1, image2;
-  GetImagesInMarkers(markers, &image1, &image2);
+  int camera1, camera2;
+  GetImagesAndCamerasInMarkers(markers, &image1, &image2, &camera1, &camera2);
 
   Mat x1, x2;
   CoordinatesForMarkersInImage(markers, image1, &x1);
@@ -186,8 +191,8 @@
   Mat34 P2;
   ProjectionsFromFundamental(F, &P1, &P2);
 
-  reconstruction->InsertCamera(image1, P1);
-  reconstruction->InsertCamera(image2, P2);
+  reconstruction->InsertView(image1, P1, camera1);
+  reconstruction->InsertView(image2, P2, camera2);
 
   LG << "From two frame reconstruction got P2:\n" << P2;
   return true;
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.h svn/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.h
--- trunk/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/initialize_reconstruction.h	2013-09-14 11:24:31.000000000 +0100
@@ -34,8 +34,8 @@
     two frames.
 
     \a markers should contain all \l Marker markers \endlink belonging to
-    tracks visible in both frames. The pose estimation of the camera for
-    these frames will be inserted into \a *reconstruction.
+    tracks visible in both frames from the same camera. The pose estimation of
+    the camera for these frames will be inserted into \a *reconstruction.
 
     \note The two frames need to have both enough parallax and enough common tracks
           for accurate reconstruction. At least 8 tracks are suggested.
@@ -55,8 +55,8 @@
     two frames.
 
     \a markers should contain all \l Marker markers \endlink belonging to
-    tracks visible in both frames. An estimate of the projection matrices for
-    the two frames will get added to the reconstruction.
+    tracks visible in both frames from the same camera. An estimate of the
+    projection matrices for the two frames will get added to the reconstruction.
 
     \note The two frames need to have both enough parallax and enough common tracks
           for accurate reconstruction. At least 8 tracks are suggested.
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/intersect.cc svn/extern/libmv/libmv/simple_pipeline/intersect.cc
--- trunk/extern/libmv/libmv/simple_pipeline/intersect.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/intersect.cc	2013-09-14 11:24:31.000000000 +0100
@@ -39,8 +39,8 @@
 class EuclideanIntersectCostFunctor {
  public:
   EuclideanIntersectCostFunctor(const Marker &marker,
-                                const EuclideanCamera &camera)
-      : marker_(marker), camera_(camera) {}
+                                const EuclideanView &view)
+      : marker_(marker), view_(view) {}
 
   template<typename T>
   bool operator()(const T *X, T *residuals) const {
@@ -48,8 +48,8 @@
     typedef Eigen::Matrix<T, 3, 1> Vec3;
 
     Vec3 x(X);
-    Mat3 R(camera_.R.cast<T>());
-    Vec3 t(camera_.t.cast<T>());
+    Mat3 R(view_.R.cast<T>());
+    Vec3 t(view_.t.cast<T>());
 
     Vec3 projected = R * x + t;
     projected /= projected(2);
@@ -61,7 +61,7 @@
   }
 
   const Marker &marker_;
-  const EuclideanCamera &camera_;
+  const EuclideanView &view_;
 };
 
 }  // namespace
@@ -78,8 +78,8 @@
   vector<Mat34> cameras;
   Mat34 P;
   for (int i = 0; i < markers.size(); ++i) {
-    EuclideanCamera *camera = reconstruction->CameraForImage(markers[i].image);
-    P_From_KRt(K, camera->R, camera->t, &P);
+    EuclideanView *view = reconstruction->ViewForImage(markers[i].image);
+    P_From_KRt(K, view->R, view->t, &P);
     cameras.push_back(P);
   }
 
@@ -102,14 +102,14 @@
 
   for (int i = 0; i < markers.size(); ++i) {
     const Marker &marker = markers[i];
-    const EuclideanCamera &camera =
-        *reconstruction->CameraForImage(marker.image);
+    const EuclideanView &view =
+        *reconstruction->ViewForImage(marker.image);
 
     problem.AddResidualBlock(
         new ceres::AutoDiffCostFunction<
             EuclideanIntersectCostFunctor,
             2, /* num_residuals */
-            3>(new EuclideanIntersectCostFunctor(marker, camera)),
+            3>(new EuclideanIntersectCostFunctor(marker, view)),
         NULL,
         &X(0));
   }
@@ -130,9 +130,9 @@
 
   // Try projecting the point; make sure it's in front of everyone.
   for (int i = 0; i < cameras.size(); ++i) {
-    const EuclideanCamera &camera =
-        *reconstruction->CameraForImage(markers[i].image);
-    Vec3 x = camera.R * X + camera.t;
+    const EuclideanView &view =
+        *reconstruction->ViewForImage(markers[i].image);
+    Vec3 x = view.R * X + view.t;
     if (x(2) < 0) {
       LOG(ERROR) << "POINT BEHIND CAMERA " << markers[i].image
                  << ": " << x.transpose();
@@ -163,9 +163,9 @@
     Vec residuals(2 * markers.size());
     residuals.setZero();
     for (int i = 0; i < markers.size(); ++i) {
-      const ProjectiveCamera &camera =
-          *reconstruction.CameraForImage(markers[i].image);
-      Vec3 projected = camera.P * X;
+      const ProjectiveView &view =
+          *reconstruction.ViewForImage(markers[i].image);
+      Vec3 projected = view.P * X;
       projected /= projected(2);
       residuals[2*i + 0] = projected(0) - markers[i].x;
       residuals[2*i + 1] = projected(1) - markers[i].y;
@@ -187,8 +187,8 @@
   // Get the cameras to use for the intersection.
   vector<Mat34> cameras;
   for (int i = 0; i < markers.size(); ++i) {
-    ProjectiveCamera *camera = reconstruction->CameraForImage(markers[i].image);
-    cameras.push_back(camera->P);
+    ProjectiveView *view = reconstruction->ViewForImage(markers[i].image);
+    cameras.push_back(view->P);
   }
 
   // Stack the 2D coordinates together as required by NViewTriangulate.
@@ -214,9 +214,9 @@
 
   // Try projecting the point; make sure it's in front of everyone.
   for (int i = 0; i < cameras.size(); ++i) {
-    const ProjectiveCamera &camera =
-        *reconstruction->CameraForImage(markers[i].image);
-    Vec3 x = camera.P * X;
+    const ProjectiveView &view =
+        *reconstruction->ViewForImage(markers[i].image);
+    Vec3 x = view.P * X;
     if (x(2) < 0) {
       LOG(ERROR) << "POINT BEHIND CAMERA " << markers[i].image
                  << ": " << x.transpose();
